package healthwatcher.aspects.concurrency;

import healthwatcher.data.mem.ComplaintRepositoryArray;
import healthwatcher.data.mem.EmployeeRepositoryArray;

import edu.iastate.cs.ptolemy.runtime.*;
import healthwatcher.aspects.concurrency.events.*;

/**
 * This aspect synchronizes execution of all methods of classes declared synchronized 
 * classes (in this case, EmployeeRepositoryArray and ComplaintRepositoryArray)
 */
@Instantiation(Instantiation.Model.SINGLETON)
@Registration(Registration.Model.IMPLICIT)
public class HWLocalSynchronization {

	public void handler(SynchronizedMethodEvent next) throws Throwable {
		synchronized(next.obj) {
			invoke(next);
		}
	}
	when SynchronizedMethodEvent do handler;

	public Object handler(SynchronizedObjectMethodEvent next) throws Throwable {
		synchronized(next.obj) {
			return invoke(next);
		}
	}
	when SynchronizedObjectMethodEvent do handler;
}
