package healthwatcher.aspects.distribution;

import healthwatcher.view.IFacade;
import healthwatcher.view.command.CommandServlet;
import lib.exceptions.CommunicationException;
import lib.util.IteratorDsk;

import edu.iastate.cs.ptolemy.runtime.*;
import healthwatcher.aspects.distribution.events.*;

/**
 * An abstract client distribution for the HW system. 
 * Concrete clients should use the facadeCalls() pointcut to intercept calls to the facade and 
 * distribute them over the network.
 */
@Instantiation(Instantiation.Model.SINGLETON)
public abstract class HWClientDistribution {
	
    /**
     * Redirects the facade methods call to the distributed instance methods using reflection
     */
    protected void initExceptionHandling(Throwable exception) {
    	String error =  "<p>****************************************************<br>" +
                 "Error during servlet initialization!<br>" +
                 "The exception message is:<br><dd>" + exception.getMessage() +
                 "<p>You may have to restart the servlet container.<br>" +
                 "*******************************************************";
        System.out.println(error);
    }
}
