package healthwatcher.aspects.exceptionHandling;

import healthwatcher.view.servlets.HWServlet;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import lib.exceptions.TransactionException;
import lib.util.HTMLCode;

import org.aspectj.lang.SoftException;

import edu.iastate.cs.ptolemy.runtime.*;
import healthwatcher.aspects.exceptionHandling.events.*;

/**
 * This aspect handles transaction exceptions in the servlets
 */
@Instantiation(Instantiation.Model.SINGLETON)
@Registration(Registration.Model.IMPLICIT)
@PrecedesHandler(healthwatcher.aspects.patterns.ServletCommanding.class)
public class HWTransactionExceptionHandler {

	public void handler(HWServletExEvent next) throws Throwable {
		
		try {
			
			invoke(next);
			
        } catch (SoftException e) {
        	if (e.getWrappedThrowable() instanceof TransactionException) {
        		PrintWriter out = next.response.getWriter();
        		out.println(HTMLCode.errorPage(e.getWrappedThrowable().getMessage()));
        		out.close();
        	} else {
        		throw e;
        	}
		}
	}
	when HWServletExEvent do handler;
}
