package healthwatcher.aspects.patterns.complaintState;

import healthwatcher.model.address.Address;
import healthwatcher.model.complaint.AnimalComplaint;
import healthwatcher.model.complaint.Situation;
import healthwatcher.model.complaint.state.AnimalComplaintState;
import healthwatcher.model.complaint.state.AnimalComplaintStateClosed;
import healthwatcher.model.complaint.state.AnimalComplaintStateOpen;
import healthwatcher.model.employee.Employee;
import lib.util.Date;

import edu.iastate.cs.ptolemy.runtime.*;
import healthwatcher.aspects.patterns.events.*;



@Instantiation(Instantiation.Model.SINGLETON)
@Registration(Registration.Model.IMPLICIT)
public class AnimalComplaintStateAspect {
	
	public void handler(NewOpenComplaintEvent next) throws Throwable {
    	invoke(next);
    	if (next.complaint instanceof AnimalComplaint)
    		((AnimalComplaint)next.complaint).setComplaintState( new AnimalComplaintStateOpen() );
	}
	when NewOpenComplaintEvent do handler;
	
	public void handler(NewAnimalComplaintEvent next) throws Throwable {
		invoke(next);
		if (next.animalComplaint.getSituacao() == Situation.QUEIXA_ABERTA)
			next.animalComplaint.setComplaintState( new AnimalComplaintStateOpen(next.qtdeAnimais, next.dataIncomodo,
					next.animal, next.endereco) ) ;
		else if (next.animalComplaint.getSituacao() == Situation.QUEIXA_FECHADA)
			next.animalComplaint.setComplaintState( new AnimalComplaintStateClosed(next.qtdeAnimais, next.dataIncomodo,
					next.animal, next.endereco) );
	}
	when NewAnimalComplaintEvent do handler;

	public void handler(AnimalComplaintSetStatusEvent next) throws Throwable {
    	invoke(next);
    	if( next.status != next.complaint.getSituacao()){
    		if( next.status ==Situation.QUEIXA_ABERTA){
    			next.complaint.setComplaintState(new AnimalComplaintStateOpen(next.state.getQtdeAnimais(), next.state.getDataIncomodo(), next.state.getAnimal(), next.state.getEnderecoLocalOcorrencia()));
    		}else if( next.status ==Situation.QUEIXA_FECHADA){
    			next.complaint.setComplaintState(new AnimalComplaintStateClosed(next.state.getQtdeAnimais(), next.state.getDataIncomodo(), next.state.getAnimal(), next.state.getEnderecoLocalOcorrencia()));
    		}else if(next.status==Situation.QUEIXA_SUSPENSA){
    			
    		}
    	}

	}
	when AnimalComplaintSetStatusEvent do handler;

	
}
