package healthwatcher.aspects.patterns.complaintState;

import healthwatcher.model.address.Address;
import healthwatcher.model.complaint.FoodComplaint;
import healthwatcher.model.complaint.Situation;
import healthwatcher.model.complaint.state.FoodComplaintState;
import healthwatcher.model.complaint.state.FoodComplaintStateClosed;
import healthwatcher.model.complaint.state.FoodComplaintStateOpen;
import healthwatcher.model.employee.Employee;
import lib.util.Date;

import edu.iastate.cs.ptolemy.runtime.*;
import healthwatcher.aspects.patterns.events.*;



@Instantiation(Instantiation.Model.SINGLETON)
@Registration(Registration.Model.IMPLICIT)
public class FoodComplaintStateAspect {
	
	public void handler(NewOpenComplaintEvent next) throws Throwable {
    	invoke(next);
    	if (next.complaint instanceof FoodComplaint)
    		((FoodComplaint)next.complaint).setComplaintState( new FoodComplaintStateOpen() );
	}
	when NewOpenComplaintEvent do handler;
	
	public void handler(NewFoodComplaintEvent next) throws Throwable {
    	invoke(next);
		if (next.foodComplaint.getSituacao() == Situation.QUEIXA_ABERTA)
			next.foodComplaint.setComplaintState( new FoodComplaintStateOpen(next.qtdeComensais, next.qtdeDoentes, next.qtdeInternacoes,
					next.qtdeObitos, next.localAtendimento, next.refeicaoSuspeita, next.enderecoDoente) ) ;
		else if (next.foodComplaint.getSituacao() == Situation.QUEIXA_FECHADA)
			next.foodComplaint.setComplaintState( new FoodComplaintStateClosed(next.qtdeComensais, next.qtdeDoentes, next.qtdeInternacoes,
					next.qtdeObitos, next.localAtendimento, next.refeicaoSuspeita, next.enderecoDoente) );
	}
	when NewFoodComplaintEvent do handler;

	public void handler(FoodComplaintSetStatusEvent next) throws Throwable {
    	invoke(next);
    	if( next.status != next.complaint.getSituacao()){
    		if( next.status ==Situation.QUEIXA_ABERTA){
    			next.complaint.setComplaintState(new FoodComplaintStateOpen(next.state.getQtdeComensais(), next.state.getQtdeDoentes(), next.state.getQtdeInternacoes(),
    					next.state.getQtdeObitos(), next.state.getLocalAtendimento(), next.state.getRefeicaoSuspeita(), next.state.getEnderecoDoente()));
    		}else if( next.status ==Situation.QUEIXA_FECHADA){
    			next.complaint.setComplaintState(new FoodComplaintStateClosed(next.state.getQtdeComensais(), next.state.getQtdeDoentes(), next.state.getQtdeInternacoes(),
    					next.state.getQtdeObitos(), next.state.getLocalAtendimento(), next.state.getRefeicaoSuspeita(), next.state.getEnderecoDoente()));
    		}else if(next.status==Situation.QUEIXA_SUSPENSA){
    			
    		}
    	}

	}
	when FoodComplaintSetStatusEvent do handler;

	
}
