package healthwatcher.aspects.patterns.complaintState;

import healthwatcher.model.address.Address;
import healthwatcher.model.complaint.Situation;
import healthwatcher.model.complaint.SpecialComplaint;
import healthwatcher.model.complaint.state.SpecialComplaintState;
import healthwatcher.model.complaint.state.SpecialComplaintStateClosed;
import healthwatcher.model.complaint.state.SpecialComplaintStateOpen;
import healthwatcher.model.employee.Employee;
import lib.util.Date;

import edu.iastate.cs.ptolemy.runtime.*;
import healthwatcher.aspects.patterns.events.*;



@Instantiation(Instantiation.Model.SINGLETON)
@Registration(Registration.Model.IMPLICIT)
public class SpecialComplaintStateAspect {
	
	public void handler(NewOpenComplaintEvent next) throws Throwable {
    	invoke(next);
    	if (next.complaint instanceof SpecialComplaint)
    		((SpecialComplaint)next.complaint).setComplaintState( new SpecialComplaintStateOpen() );
	}
	when NewOpenComplaintEvent do handler;
	
	public void handler(NewSpecialComplaintEvent next) throws Throwable {
    	invoke(next);
		if (next.specialComplaint.getSituacao() == Situation.QUEIXA_ABERTA)
			next.specialComplaint.setComplaintState( new SpecialComplaintStateOpen(next.idade, next.instrucao, next.ocupacao,  next.enderecoOcorrencia) ) ;
		else if (next.specialComplaint.getSituacao() == Situation.QUEIXA_FECHADA)
			next.specialComplaint.setComplaintState( new SpecialComplaintStateClosed(next.idade, next.instrucao, next.ocupacao,  next.enderecoOcorrencia) );
	}
	when NewSpecialComplaintEvent do handler;

	public void handler(SpecialComplaintSetStatusEvent next) throws Throwable {
    	invoke(next);
    	if( next.status != next.complaint.getSituacao()){
    		if( next.status ==Situation.QUEIXA_ABERTA){
    			next.complaint.setComplaintState(new SpecialComplaintStateOpen(next.state.getIdade(), next.state.getInstrucao(), next.state.getOcupacao(),  next.state.getEnderecoOcorrencia()));
    		}else if( next.status ==Situation.QUEIXA_FECHADA){
    			next.complaint.setComplaintState(new SpecialComplaintStateClosed(next.state.getIdade(), next.state.getInstrucao(), next.state.getOcupacao(), next.state.getEnderecoOcorrencia()));
    		}else if(next.status==Situation.QUEIXA_SUSPENSA){
    			
    		}
    	}

	}
	when SpecialComplaintSetStatusEvent do handler;

	
}
