package healthwatcher.model.employee;

import lib.patterns.events.*;

public class Employee implements java.io.Serializable {

	private String name;

	private String login;

	private String password;

	public Employee(String login, String password, String name) {
		this.name = name;
		this.login = login;
		this.password = password;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		announce SubjectChangeEvent(this) {
			this.name = name;
		}
	}

	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		announce SubjectChangeEvent(this) {
			this.login = login;
		}
	}

	public void setPassword(String password) {
		announce SubjectChangeEvent(this) {
			this.password = password;
		}
	}

	public String getPassword() {
		return password;
	}

	public boolean validatePassword(String password) {
		return this.password.equals(password);
	}
}