package healthwatcher.view.command;


import healthwatcher.model.healthguide.HealthUnit;

import java.io.IOException;
import java.io.PrintWriter;

import lib.exceptions.InvalidSessionException;
import lib.patterns.CommandReceiver;
import lib.util.HTMLCode;

import healthwatcher.aspects.exceptionHandling.events.*;
import healthwatcher.aspects.concurrency.events.*;



public class UpdateHealthUnitData extends CommandServlet {

	public void executeCommand(CommandReceiver receiver) throws IOException {
		announce ExecuteCommandEvent() {
			announce UpdateDataExecuteCommandEvent(this) {
		        PrintWriter out = response.getWriter();
		
		        HealthUnit unit;
		        
		        try {
		        	if (! request.isAuthorized()) {
		                throw new InvalidSessionException();
		            }
		        	
		        	unit = (HealthUnit) request.get(UpdateHealthUnitSearch.HEALTH_UNIT);                        
		            
		            String descricao = request.getInput("descricao");            
		            
		            unit.setDescription(descricao);
		        	
		            out.println(HTMLCode.htmlPageAdministrator("Operation executed", "Health Unit updated"));
		
		        } catch(Exception e){
		            out.println(lib.util.HTMLCode.errorPage("Comunitation error, please try again later."));
		        }
			}
		}
	}
}
